#           +-----------------------------------------------------------+
#           Table Unicode Art by h.kassem version 1.1                  
#                                                                      
#                                                                      
#                                                                      
#           -----------------------------------------------------------
#           ART                ASCII              UNICODE            
#                                                                    
#                                                                    
#                                                                    
#           -------------------+-------------------+-------------------
#           Under                                                 
#           GPL                                                   
#           license                                               
#                                                                 
#                    ---------+---------+---------+---------+---------
#                                                                 
#                                                                 
#                                                                 
#                                                                 
#           +-----------------------------------------------------------+


set ::TS "\u2554"
set ::BS "\u255A"
set ::TE "\u2557"
set ::BE "\u255D"
set ::MLS "\u2566"
set ::MLE "\u2569"
set ::MCS "\u2560"
set ::MCE "\u2563"
set ::L "\u2550"
set ::C "\u2551"
set ::J "\u256C"

set ::LeftPad "        "
catch { 
unset ::Table
unset ::Match
unset ::Corner
array set ::Table ""
array set ::Match ""
array set ::Corner ""
}

set ::fid [open "./asciiArtTable_out.txt" w]
fconfigure $::fid -encoding utf-8
		
proc wrapLine {line x} {
	set data [join $line " "]
	list Xdata ""
	set temp ""
	set d $x
	foreach e $data {
		set L [string length $e]
		if {$L < $d} {
			append temp "$e "
		} else {
			lappend Xdata "$temp"
			set temp "$e "
			set d $x
		}
		set d [expr $d - $L - 1]
	}
	lappend Xdata "$temp"
	#foreach e $Xdata {
	#	puts $e
	#}
	return $Xdata
}

proc getxy {pointNumber a b} {
	set rect "$::Match($a,$b)"
	return  [lindex $rect [expr $pointNumber - 1]]
}

proc getx {point} {
	return [lindex [split $point ","] 0]
}

proc gety {point} {
	return [lindex [split $point ","] 1]
}

proc getCell {a b} {
	# Cells
	return "$::Match($a,$b)"
}

proc swap {i j a b} {
	return "$a $b $i $j"
}

proc mergeClone {oldData newData} {
	for {set cmpt 1} {$cmpt <= $::Match(END)} {incr cmpt} {
		if {$oldData == $::Match($cmpt)} {
			set ::Match($cmpt) "$newData"
			set ij $::Match(index,$cmpt)
			set ::Match($ij) "$newData"
		}
	}
}

proc mergeCell {cell1 cell2} {
    set cell1 [lindex [split $cell1 "<>"] 1]
    set cell2 [lindex [split $cell2 "<>"] 1]
    set i [lindex [split $cell1 ","] 0]
	set j [lindex [split $cell1 ","] 1]
	set a [lindex [split $cell2 ","] 0]
	set b [lindex [split $cell2 ","] 1]
	
    if {$i > $a || $j > $b} {
	    set s [swap $i $j $a $b]
		set i [lindex $s 0]
		set j [lindex $s 1]
		set a [lindex $s 2]
		set b [lindex $s 3]
	}
	
	if {$i == $a} {
		set point2 [getxy 2 $i $j]
		set point4 [getxy 4 $i $j]
		dropLine $point2 $point4
	    set point1 [getxy 1 $i $j]
		set point2 [getxy 2 $a $b]
		set point3 [getxy 3 $i $j]
		set point4 [getxy 4 $a $b]
		
		set cmpt $::Match(index,$i,$j)
		set newData "$point1 $point2 $point3 $point4"
		set oldData $::Match($i,$j)
		set ::Match($cmpt) "$newData"
		set ::Match($i,$j) "$newData"
		mergeClone $oldData $newData
		set cmpt $::Match(index,$a,$b)
		set oldData $::Match($a,$b)
		set ::Match($cmpt) "$newData"
		set ::Match($a,$b) "$newData"
		mergeClone $oldData $newData
	}

	if {$j == $b} {
		set point3 [getxy 3 $i $j]
		set point4 [getxy 4 $i $j]
		dropLine $point3 $point4
	    set point1 [getxy 1 $i $j]
		set point2 [getxy 2 $i $j]
	    set point3 [getxy 3 $a $b]
		set point4 [getxy 4 $a $b]		

		set cmpt $::Match(index,$i,$j)
		set newData "$point1 $point2 $point3 $point4"
		set oldData $::Match($i,$j)
		set ::Match($cmpt) "$newData"
		set ::Match($i,$j) "$newData"
		mergeClone $oldData $newData
		set cmpt $::Match(index,$a,$b)
		set oldData $::Match($a,$b)
		set ::Match($cmpt) "$newData"
		set ::Match($a,$b) "$newData"
		mergeClone $oldData $newData		
	}
}

proc setCell {cell data} {
    set cell [lindex [split $cell "<>"] 1]
    set a [lindex [split $cell ","] 0]
	set b [lindex [split $cell ","] 1]
	# Cells
	set point1 [getxy 1 $a $b]
	set point4 [getxy 4 $a $b]

	set x1 [getx $point1]
	set y1 [gety $point1]
	
	set x2 [getx $point4]
	set y2 [gety $point4]
	set data [wrapLine $data [expr $x2-$x1-2]]
	set cmpt2 0
	for {set i [expr 1 + $y1]} {$i <= [expr $y2-1]} {incr i} {
		set data2 [lindex $data $cmpt2]
		incr cmpt2
		set cmpt 0
		for {set j [expr 1 + $x1]} {$j <= [expr $x2-1]} {incr j} {
			set ::Table($j,$i) "[string range $data2 $cmpt $cmpt]"
			incr cmpt
		}
	}
}

proc init {L C padx pady} {
    set cmpt 0
	for {set i 1} {$i <= $L} {incr i} {
		for {set j 1} {$j <= $C} {incr j} {
			# Cells
			incr cmpt
			set y1 [expr 1+ ($i-1)*$pady]
			set x1 [expr 1+ ($j-1)*$padx]
			set y2 [expr 1+ ($i)*$pady]
			set x2 [expr 1+ ($j)*$padx]
			set ::Match($cmpt) "$x1,$y1 $x2,$y1 $x1,$y2 $x2,$y2"
			set ::Match($i,$j) "$x1,$y1 $x2,$y1 $x1,$y2 $x2,$y2" 
			set ::Match(index,$i,$j) $cmpt
			set ::Match(index,$cmpt) "$i,$j"
			set ::Corner($x1,$y1) "ABCD"
			set ::Corner($x2,$y1) "ABCD"
			set ::Corner($x1,$y2) "ABCD"
			set ::Corner($x2,$y2) "ABCD"
			
			if {$i == 1} {
				set ::Corner($x1,1) "AB"
			}
			if {$j == 1} {
				set ::Corner(1,$y1) "AC"
			}
			if {$i == $L} {
				set ::Corner($x1,$y2) "CD"
			}
			if {$j == $C} {
				set ::Corner($x2,$y1) "BD"
			}			
		}
	}
	set ::Corner(1,1) "A"
    set ::Corner(1,$y2) "C"
	set ::Corner($x2,1) "B"
	set ::Corner($x2,$y2) "D"
	
	set ::Match(END) $cmpt
    set ::Match(BEGIN) 1
	set ::Match(L) [expr $C*$padx+1]
	set ::Match(C) [expr $L*$pady+1]
}
proc getTag {t} {
	switch $t {
		"A" { return $::TS}
		"B" { return $::TE}
		"C" { return $::BS}
		"D" { return $::BE}
		"AB" { return $::MLS}
		"AC" { return $::MCS}
		"BD" { return $::MCE}
		"CD" { return $::MLE}
		"ABCD" { return $::J}
		"V" { return $::C}
		"H" { return $::L}
		 default { return $::J}
	}
}

proc drawLine {point1 point2} {
	set x1 [lindex [split $point1 ","] 0]
	set y1 [lindex [split $point1 ","] 1]
	
	set x2 [lindex [split $point2 ","] 0]
	set y2 [lindex [split $point2 ","] 1]

	if {$x1 == $x2} {	
		for {set i $y1} {$i <= $y2} {incr i} {
			set ::Table($x1,$i) "$::C"
		}
	} elseif {$y1 == $y2} {
		for {set i $x1} {$i <= $x2} {incr i} {
			set ::Table($i,$y1) "$::L"
		}	
	}
	
	# tag
	set ::Table($x1,$y1) "[getTag $::Corner($x1,$y1)]"
	set ::Table($x2,$y2) "[getTag $::Corner($x2,$y2)]"
}

proc trim {t s} {
 
    if {$t == "ABCD"} {
		switch $s {
		   "VT" { return "AB" }
		   "VB" { return "CD" }
		   "HR" { return "BD" }
		   "HL" { return "AC" }
		}
	}
	
	if {$t == "AB"} {
		return "H"
	}
	
	if {$t == "CD"} {
		return "H"
	}

	if {$t == "AC"} {
		return "V"
	}
	
	if {$t == "BD"} {
		return "V"
	}
	return $t

}

proc dropLine {point1 point2} {
	set x1 [lindex [split $point1 ","] 0]
	set y1 [lindex [split $point1 ","] 1]
	
	set x2 [lindex [split $point2 ","] 0]
	set y2 [lindex [split $point2 ","] 1]
    
	# tag
	set t1 "$::Corner($x1,$y1)"
    set t2 "$::Corner($x2,$y2)"
	
	if {$x1 == $x2} {	
		for {set i $y1} {$i <= $y2} {incr i} {
			set ::Table($x1,$i) ""
		}
		set ::Table($x1,$y1) "[getTag [trim $t1 VB]]"
		set ::Table($x2,$y2) "[getTag [trim $t2 VT]]"
		set ::Corner($x1,$y1) "[trim $t1 VB]"
		set ::Corner($x2,$y2) "[trim $t1 VT]"
		
	} elseif {$y1 == $y2} {
		for {set i $x1} {$i <= $x2} {incr i} {
			set ::Table($i,$y1) ""
		}
        set ::Table($x1,$y1) "[getTag [trim $t1 HR]]"
		set ::Table($x2,$y2) "[getTag [trim $t2 HL]]"
		set ::Corner($x1,$y1) "[trim $t1 HR]"
		set ::Corner($x2,$y2) "[trim $t1 HL]"
	}

}

proc fillTable {} {
	for {set i 1} {$i <= $::Match(END)} {incr i} {
		set cell $::Match($i)
		set point1 [lindex $cell 0]
		set point2 [lindex $cell 1]
		set point3 [lindex $cell 2]
		set point4 [lindex $cell 3]		
		drawLine $point1 $point2
		drawLine $point3 $point4
		drawLine $point1 $point3
		drawLine $point2 $point4
	}
}

proc initTable {} {
	for {set i 1} {$i <= $::Match(L)} {incr i} {
		for {set j 1} {$j <= $::Match(C)} {incr j} {
			set ::Table($i,$j) ""
		}
	}
}

proc getCell {} {

}
 
proc show {} {
    append data " $::LeftPad"
	for {set a 1} {$a <= $::Match(C)} {incr a} {
		for {set b 1} {$b <= $::Match(L)} {incr b} {
			if {$::Table($b,$a) == ""} {
				append data " "
			} else {
				append data "$::Table($b,$a)"
			}
		}
		append data "\n $::LeftPad"
	}
	puts $data
	puts $::fid $data
}

proc table {L C {LS "4"}} {
    set LS [lindex [split $LS "="] 1]
	set ::LeftPad ""
	for {set i 1} {$i <= $LS } {incr i} {
	    append ::LeftPad " "
	}
    set L [lindex [split $L "="] 1]
	set C [lindex [split $C "="] 1]
    set m [lindex [split $L ","] 0]
	set n [lindex [split $C ","] 0]
    set px [lindex [split [lindex [split $C ","] 1] "px"] 0]
	set py [lindex [split [lindex [split $L ","] 1] "px"] 0]
	
	set ::nbOfRows $L
	set ::nbOfCols $C
	init $m $n $px $py
	initTable
	fillTable
	fillTrace
}

proc merge args {
    foreach e $args {
	
		   set a [lindex [split $e "="] 0]
		   set b [lindex [split $e "="] 1]
		   set a [lindex [split $a "<>"] 1] 
		   set b [lindex [split $b "<>"] 1]
		   set a1 [lindex [split $a ","] 0] 
		   set a2 [lindex [split $a ","] 1]
		   set b1 [lindex [split $b ","] 0] 
		   set b2 [lindex [split $b ","] 1]

		   if {$a1 == $b1} {
		       for {set i $a2} {$i < $b2 } {incr i} {
			    mergeCell "<$a1\,$i>" "<$b1\,[expr $i+1]>"
			   }
		   }
		   if {$a2 == $b2} {
		       for {set i $a1} {$i < $b1 } {incr i} {
			    mergeCell "<$i\,$a2>" "<[expr $i+1],$b2\>"
			   }
		   }
	   }
}

proc fill {cell equ data} {
	setCell $cell $data
}

proc fillTrace { {File ""} } {

    for {set i 1} {$i <= $::nbOfRows} {incr i} {
		for {set j 1} {$j <= $::nbOfCols } {incr j} {
		    fill <$i,$j> = <$i,$j>
		}
	}
}
##############################################################################
#  example
##############################################################################
#table L=4,5px C=6,10px LS=10
#merge <2,1>=<2,2> <2,3>=<2,4> <2,5>=<2,6> <3,1>=<4,1> <1,1>=<1,6>
#fill <1,1> = "Table Unicode Art by h.kassem version 1.1"
#fill <2,1> = "ART"
#fill <2,3> = "ASCII"
#fill <2,5> = "UNICODE"
#fill <4,1> = "Under GPL license"
#show
##################################################################################

proc run {} {
    set f [open "./input_cmd.txt" r]
	set data ""
	while {1} {
		append data "[gets $f] \n"
		# Abort if End of file
		if {[eof $f]} { ; close $f ; break ; }
    }
	eval $data
}
run